/*
 * Created on 02.06.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2455 $
 *  $Date: 2006-09-12 17:43:11 +0200 (Di, 12 Sep 2006) $
 *  $Id: FieldIdInfoDialog.java 2455 2006-09-12 17:43:11 +0200 (Di, 12 Sep 2006) LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.ui.dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;

import de.fhOsnabrueck.jump.pirol.utilities.debugOutput.DebugUserIds;
import de.fhOsnabrueck.jump.pirol.utilities.debugOutput.PersonalLogger;

/**
 * 
 * TODO: comment class
 *
 * <br><br><b>Last change by $Author: LBST-PF-3\orahn $ on $Date: 2006-09-12 17:43:11 +0200 (Di, 12 Sep 2006) $</b>
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2006),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2455 $
 *
 */
public class HtmlInfoDialog extends JDialog implements WindowFocusListener{

	private static final long serialVersionUID = 6212112534121445192L;

	protected JEditorPane htmlPanel = null;
	
	protected long timeWhenOpened = -1;
	protected final static long minOpenTime = 1000;
	
	protected PersonalLogger logger = new PersonalLogger(DebugUserIds.OLE);

	/**
	 * @param parent
	 * @param title
	 * @param modal
	 */
	public HtmlInfoDialog(Frame parent, String title, boolean modal, boolean hideOnFocusLost) {
		super(parent, title, modal);
		this.htmlPanel = new JEditorPane("text/html", "");
		
		this.getContentPane().setLayout(new BorderLayout());

		JScrollPane scrollpane = new JScrollPane(this.htmlPanel);
		
		this.getContentPane().add(scrollpane, BorderLayout.CENTER);
		
		this.setSize(new Dimension(300,300));
		
		if (hideOnFocusLost) 
			this.addWindowFocusListener(this);
	}

	public void setText(String html) {
		htmlPanel.setText(html);
	}

	public void windowGainedFocus(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void windowLostFocus(WindowEvent arg0) {
		if (System.currentTimeMillis() - this.timeWhenOpened > minOpenTime){
			this.setVisible(false);	
		}
	}

	public void setVisible(boolean visible) {
		super.setVisible(visible);
		if (visible){
			this.timeWhenOpened = System.currentTimeMillis();
		}
	}

	
}
